﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;D:\Projects\Projects\Merfish\branches\V6_3_1_PNG\src\CS-Script\AddUpdateData.cs
//css_ref Produmex.Sbo.Logex.Merfish.dll;

using System;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Merfish.BusinessObjects;
using Produmex.Sbo.Logex.Merfish.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Merfish.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Merfish.Generators.PickListRobot;

namespace AddUpdateData
{        
    class Program
    {
		static string CONNECTION_STRING = "Server=DEV_SAP9_FR;CompanyDB=SBODemo_US_53;ExtraDb=PMX_SBODemo_US_53;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";

		/// <summary>
		/// Used for logging
		/// </summary>
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        static void Main( string[] args )
        {
			RunTableOrViewSqlScripts();

            // Add/update script flows
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

                    //allowed users update qty uom2
                    updateProv.AddUpdateUserDefinedTable(typeof(PmxAllowedUsersUpdateUom2));
                    updateProv.AddUpdateUserDefinedObject(typeof(PmxAllowedUsersUpdateUom2));

                    // * UDF's *
                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider( conn );
                    SboColumnDefinitionAttribute boolColumnDef = new SboColumnDefinitionAttribute(
                       PmxShippingTypeMerfishTable.Columns.ShowInLoadBuilder.NAME_WITHOUT_U_,
                       PmxShippingTypeMerfishTable.Columns.ShowInLoadBuilder.DESCR,
                       PmxShippingTypeMerfishTable.Columns.ShowInLoadBuilder.TYPE,
                       PmxShippingTypeMerfishTable.Columns.ShowInLoadBuilder.SIZE,
                       PmxShippingTypeMerfishTable.Columns.ShowInLoadBuilder.SUB_TYPE );
                    boolColumnDef.SboBOColumnConverterType = typeof( SboBooleanConvertor );
                    boolColumnDef.IsMandatory = true;
                    boolColumnDef.CanBeNull = false;
                    boolColumnDef.DefaultValue = "Y";
                    udfProv.AddUpdateUserfield( "OSHP", boolColumnDef );
                    // * UDF's *

					updateProv.AddUpdateExtension(PickListRobot.IDs.ExtCode, "Merfish Pick List robot", typeof(Produmex.Sbo.Logex.Merfish.Generators.PickListRobot.PickListRobot), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTROBOT);

					AddUpdateExtensionParameters_PickListRobot(updateProv);

                    scope.Complete();
                }
            }
        }

		private static void AddUpdateExtensionParameters_PickListRobot(PmxDbVersionUpdaterProvider updateProv)
		{
			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamViewSalesOrdersForProposals,
				"View of Sales Orders for creating Picklist Proposals",
				"PMX_MEF_SALES_ORDERS_FOR_PROPOSALS",
                PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_VIEW_SALES_ORDERS_FOR_PROPOSALS
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamViewSalesOrdersForProposalsOrderBy,
				"View of Sales Orders for creating Picklist Proposals Order By",
				"SalesOrderDocDueDate, SalesOrderDocEntry",
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_VIEW_SALES_ORDERS_FOR_PROPOSALS_ORDER_BY
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamViewSalesOrdersToClose,
				"View of Sales Orders to close",
				"PMX_MEF_SALES_ORDER_LINES_TO_CLOSE",
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_VIEW_SALES_ORDER_LINES_TO_CLOSE
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamMailRecipients,
				"Mail recipients",
				"sales@merfish.com;mbarton@merfish.com;caguilar@merfish.com",
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_MAIL_RECIPIENTS
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamMailHost,
				"Mail host",
				null,
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_MAIL_HOST
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamMailSentFrom,
				"Mail sent from",
				null,
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_MAIL_SENT_FROM
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv, 
				PickListRobot.IDs.ExtParamViewForMails,
				"View for mails",
				"PMX_MEF_REPORT_FOR_MAIL",
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_VIEW_FOR_MAILS
				);

			AddUpdateStringExtensionParameterString_PickListRobot(updateProv,
				PickListRobot.IDs.ExtParamMailUsername,
				"Mail username",
				null,
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_MAIL_USERNAME
				);

			AddUpdateStringExtensionParameterPassword_PickListRobot(updateProv,
				PickListRobot.IDs.ExtParamMailPassword,
				"Mail password",
				null,
				PmxExtensionParameterCodesMerfish.PICKLIST_ROBOT_MAIL_PASSWORD
				);
		}

		private static void AddUpdateStringExtensionParameterString_PickListRobot(PmxDbVersionUpdaterProvider updateProv, string code, string name, string defaultValue, string generalParameterCode)
		{
			AddUpdateStringExtensionParameter_PickListRobot(updateProv, code, name, PmxExtensionCodes.SYSTEM_STRING_CONVERTOR, defaultValue, generalParameterCode);
		}

		private static void AddUpdateStringExtensionParameterPassword_PickListRobot(PmxDbVersionUpdaterProvider updateProv, string code, string name, string defaultValue, string generalParameterCode)
		{
			AddUpdateStringExtensionParameter_PickListRobot(updateProv, code, name, PmxExtensionCodes.SYSTEM_PASSWORD_CONVERTOR, defaultValue, generalParameterCode);
		}

		private static void AddUpdateStringExtensionParameter_PickListRobot(PmxDbVersionUpdaterProvider updateProv, string code, string name, string convertorCode, string defaultValue, string generalParameterCode)
		{
			updateProv.AddUpdateExtensionParameter(code,
				name,
				PickListRobot.IDs.ExtCode,
				convertorCode,
				defaultValue,
				generalParameterCode,
                0,
                generalParameterCode
                );
		}

		private static void RunTableOrViewSqlScripts()
		{
			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
				{
					dbConn.Open();

					Console.WriteLine("Tables");

					RunTableOrViewSqlScript("PMX_M_PRLO.sql", dbConn, false);

					Console.WriteLine("Views");

					RunTableOrViewSqlScript("PMX_MEF_SALES_ORDERS_FOR_PROPOSALS.sql", dbConn, true);
					RunTableOrViewSqlScript("PMX_MEF_SALES_ORDER_LINES_TO_CLOSE.sql", dbConn, true);
					RunTableOrViewSqlScript("PMX_MEF_REPORT_FOR_MAIL.sql", dbConn, true);
				}

				scope.Complete();
			}
		}

		private static void RunTableOrViewSqlScript(string tableScript, PmxDbConnection conn, bool isView)
		{
			string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Merfish.SboCommands)), "Produmex.Sbo.Logex.Merfish.Scripts." + (isView ? "Views." : "Tables.") + tableScript);
			SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}
    }
}
